import java.util.*;

public class checkerState
{
    // instance vars
    private String pieces = "";
    private Vector children = new Vector();
    private checkerState parent;
    private String move = "";

    // constructors
    public checkerState()
    {
        pieces = "0rrrrrrrrrrrroooooooowwwwwwwwwwww";
    } // end constructor
    
    public checkerState(checkerState cs)
    {
        this.pieces = cs.pieces;
        this.children = new Vector();
        this.parent = cs.parent;
        this.move = cs.move;
    } // end constructor

    public checkerState(String s)
    {
        this.pieces = s;
    } // end constructor

    // change move that got you to this state
    public void setMove(String s) {
        this.move = s;
    } // end setMove()
    
    public void addMove(String s)
    {
        this.move +=s;
    }

    // change parent
    public void setParent(checkerState cs) {
        this.parent = cs;
    } // end setParent()
    
    // retunr move htat got you to this state
    public String getMove() {
        return this.move;
    } // end getMove()

    // add a successor
    public void addChild(checkerState cs) {
        cs = coronate(cs);
        this.children.add(cs);
    } // end addChild()

    // return the state's succesors
    public Vector getChildren() {
        return this.children;
    } // edn getChildren()

    // return the state's parent
    public checkerState getParent() {
        return this.parent;
    } // end getParent()

    // return the pieces string
    public String getPieces()
    {
        return pieces;
    } // end getPieces()
    
    // return number of red pieces
    public int getRedPieces() {
        int temp = 0;
        for(int i = 1; i < pieces.length(); i++) {
            if(pieces.charAt(i) == 'r')
                temp++;
        }
        return temp;
    } // end getRedPieces()
    
    // return number of white pieces
    public int getWhitePieces() {
        int temp = 0;
        for(int i = 1; i < pieces.length(); i++) {
            if(pieces.charAt(i) == 'w')
                temp++;
        }
        return temp;
    } // end getWhitePieces()
    
        // return number of red pieces
    public int getRedKings() {
        int temp = 0;
        for(int i = 1; i < pieces.length(); i++) {
            if(pieces.charAt(i) == 'R')
                temp++;
        }
        return temp;
    } // end getRedPieces()
    
    // return number of white pieces
    public int getWhiteKings() {
        int temp = 0;
        for(int i = 1; i < pieces.length(); i++) {
            if(pieces.charAt(i) == 'W')
                temp++;
        }
        return temp;
    } // end getWhitePieces()
    
    // is a position a white king
    public boolean isWhiteKing(int pos)
    {
        if(pieces.charAt(pos) == 'W')
            return true;
        else
            return false;
    } // end isWhiteKing()
    
    // is a position a red king
    public boolean isRedKing(int pos)
    {
        if(pieces.charAt(pos) == 'R')
            return true;
        else
            return false;
    } // end isRedKing()
    
    // is piece at position pos a red piece
    public boolean isRedPiece(int pos)
    {
        if(pieces.charAt(pos) == 'r')
            return true;
        else
            return false;
    } // end isRedPiece()
    
    // is piece at position pos a white piece
    public boolean isWhitePiece(int pos)
    {
        if(pieces.charAt(pos) == 'w')
            return true;
        else
            return false;
    } // end isWhitePiece()
    
    // find adjacent squares to a location
    public static int[] getAdjacentSquares(int location)
    {
        int[] returnState;
        switch(location)
        {
            case 1: returnState = new int[2]; returnState[0] = 5; returnState[1] = 6; break;
            case 2: returnState = new int[2]; returnState[0] = 6; returnState[1] = 7; break;
            case 3: returnState = new int[2]; returnState[0] = 7; returnState[1] = 8; break;
            case 4: returnState = new int[1]; returnState[0] = 8; break;
            case 5: returnState = new int[2]; returnState[0] = 1; returnState[1] = 9; break;
            case 6: returnState = new int[4]; returnState[0] = 1; returnState[1] = 2; returnState[2] = 9; returnState[3] = 10; break;
            case 7: returnState = new int[4]; returnState[0] = 2; returnState[1] = 3; returnState[2] = 10; returnState[3] = 11; break;
            case 8: returnState = new int[4]; returnState[0] = 3; returnState[1] = 4; returnState[2] = 11; returnState[3] = 12;  break;
            case 9: returnState = new int[4]; returnState[0] = 5; returnState[1] = 6; returnState[2] = 13; returnState[3] = 14; break;
            case 10: returnState = new int[4]; returnState[0] = 6; returnState[1] = 7; returnState[2] = 14; returnState[3] = 15; break;
            case 11: returnState = new int[4]; returnState[0] = 7; returnState[1] = 8; returnState[2] = 15; returnState[3] = 16; break;
            case 12: returnState = new int[2]; returnState[0] = 8; returnState[1] = 16; break;
            case 13: returnState = new int[2]; returnState[0] = 9; returnState[1] = 17; break;
            case 14: returnState = new int[4]; returnState[0] = 9; returnState[1] = 10; returnState[2] = 17; returnState[3] = 18; break;
            case 15: returnState = new int[4]; returnState[0] = 10; returnState[1] = 11; returnState[2] = 18; returnState[3] = 19; break;
            case 16: returnState = new int[4]; returnState[0] = 11; returnState[1] = 12; returnState[2] = 19; returnState[3] = 20; break;
            case 17: returnState = new int[4]; returnState[0] = 13; returnState[1] = 14; returnState[2] = 21; returnState[3] = 22; break;
            case 18: returnState = new int[4]; returnState[0] = 14; returnState[1] = 15; returnState[2] = 22; returnState[3] = 23; break;
            case 19: returnState = new int[4]; returnState[0] = 15; returnState[1] = 16; returnState[2] = 23; returnState[3] = 24; break;
            case 20: returnState = new int[2]; returnState[0] = 16; returnState[1] = 24; break;
            case 21: returnState = new int[2]; returnState[0] = 17; returnState[1] = 25; break;
            case 22: returnState = new int[4]; returnState[0] = 17; returnState[1] = 18; returnState[2] = 25; returnState[3] = 26; break;
            case 23: returnState = new int[4]; returnState[0] = 18; returnState[1] = 19; returnState[2] = 26; returnState[3] = 27; break;
            case 24: returnState = new int[4]; returnState[0] = 19; returnState[1] = 20; returnState[2] = 27; returnState[3] = 28; break;
            case 25: returnState = new int[4]; returnState[0] = 21; returnState[1] = 22; returnState[2] = 29; returnState[3] = 30; break;
            case 26: returnState = new int[4]; returnState[0] = 22; returnState[1] = 23; returnState[2] = 30; returnState[3] = 31; break;
            case 27: returnState = new int[4]; returnState[0] = 23; returnState[1] = 24; returnState[2] = 31; returnState[3] = 32; break;
            case 28: returnState = new int[2]; returnState[0] = 24; returnState[1] = 32; break;
            case 29: returnState = new int[1]; returnState[0] = 25; break;
            case 30: returnState = new int[2]; returnState[0] = 25; returnState[1] = 26; break;
            case 31: returnState = new int[2]; returnState[0] = 26; returnState[1] = 27; break;
            case 32: returnState = new int[2]; returnState[0] = 27; returnState[1] = 28; break;
            default: returnState = new int[2]; returnState[0] = 0; returnState[1] = 0; break;
        }
        return returnState;
    } // end getAdjacentSquares()
    
    // remove a piece from the board
    public void remove(int location)
    {
        String temp = "";
        for(int i = 0; i < pieces.length(); i++) {
            if(i != location)
                temp += pieces.charAt(i);
            else
                temp += 'o';
        } // end for loop
        this.pieces = temp;
    } // end remove()
    
    // add a piece to the board
    public void add(int location, char type)
    {
        String temp = "";
        for(int i = 0; i < pieces.length(); i++) {
            if(i != location)
                temp += pieces.charAt(i);
            else
                temp += type;
        } // end for loop
        this.pieces = temp;
    }
    
    public void addChildren(Vector newKids)
    {
        for(int i=0; i<newKids.size(); i++)
        {
            checkerState cs = new checkerState((checkerState)(newKids.get(i)));
            cs = coronate(cs);
            children.add(cs);
        }
    }
    
    public checkerState coronate(checkerState cs)
    {
        String pieces = cs.getPieces();
        checkerState nextState = new checkerState(cs);
        for(int i =0; i<pieces.length(); i++)
        {
            if(((i==1) || (i==2) || (i==3) || (i==4)) && pieces.charAt(i) == 'w')
            {
                //king white
                nextState.remove(i);
                nextState.add(i,'W');
            }
            if(((i==29) || (i==30) || (i==31) || (i==32)) && pieces.charAt(i) == 'r')
            {
                //King red
                nextState.remove(i);
                nextState.add(i,'R');
            }
        }
        return nextState;
    }// end coronate()
    
    
    // is a space clear?
    public boolean isClear(int location)
    {
        if(pieces.charAt(location) == 'o')
            return true;
        else
            return false;
    } // end isClear()
    
    public int numEdgesPieces(boolean isWhite)
    {
        int count = 1;
        int[] temp;
        if(isWhite)
        {
            for(int i = 1; i<pieces.length(); i++)
            {
                if((pieces.charAt(i) == 'w'))
                {
                    temp = getAdjacentSquares(i);
                    if(temp.length > 2)//not on edge
                        count++;
                }
            }
        }
        else
        {
            for(int i = 1; i<pieces.length(); i++)
            {
                if((pieces.charAt(i) == 'r'))
                {
                    temp = getAdjacentSquares(i);
                    if(temp.length > 2)//not on edge
                        count++;
                }
            }
        }
        return count;
    }
    
    public int numEdgesKings(boolean isWhite)
    {
        int count = 1;
        int[] temp;
        if(isWhite)
        {
            for(int i = 1; i<pieces.length(); i++)
            {
                if((pieces.charAt(i) == 'W'))
                {
                    temp = getAdjacentSquares(i);
                    if(temp.length > 2)//not on edge
                        count++;
                }
            }
        }
        else
        {
            for(int i = 1; i<pieces.length(); i++)
            {
                if((pieces.charAt(i) == 'R'))
                {
                    temp = getAdjacentSquares(i);
                    if(temp.length > 2)//not on edge
                        count++;
                }
            }
        }
        return count;
    }
    
    // print the board
    public String toString(boolean side) {
        String temp = "-----------------\n|";
        int i;
        if(!side) {
        for(i = 1; i < 5; i++)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i < 9; i++)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------\n|";
        for(i = i; i < 13; i++)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i < 17; i++)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------\n|";
        for(i = i; i < 21; i++)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i < 25; i++)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------\n|";
        for(i = i; i < 29; i++)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i < 33; i++)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------";
       }
        else {
            for(i = 32; i > 28; i--)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i >24; i--)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------\n|";
        for(i = i; i >20 ; i--)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i > 16; i--)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------\n|";
        for(i = i; i > 12; i--)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i >8 ; i--)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------\n|";
        for(i = i; i >4; i--)
            temp += "=|" + pieces.charAt(i) + "|";
        temp += "\n-----------------\n|";
        for(i = i; i >0; i--)
            temp += pieces.charAt(i) + "|=|";
        temp += "\n-----------------";
        }
        return temp;
    } // end class toString()
}
